
//lRegen_FileHeading
//lRegen_FileHeading


     /********************************************************************
      *
      *   Source File:  travel.cpp
      *   Author:       RC
      *   Module:       C++ Source file for travel application
      *   Program Desc:
      *   Date:         Fri Apr 05 12:20:29 1996
      *   Language:     MFC C++ 3.0
      *
      ********************************************************************/

#include ".\travel.h"
#include ".\mainapp.h"
#include "ctl3d.h"
//Regen_Vars
//Regen_Vars

BEGIN_MESSAGE_MAP(CMainWindow, CDialog)
   //{{AFX_MSG_MAP(CMainWindow)
   ON_COMMAND(IDM_SHORTESTDISTANCE, OnIDM_SHORTESTDISTANCE)
   ON_COMMAND(IDM_FILE_PRINT, OnIDM_FILE_PRINT)
   ON_COMMAND(IDM_APP_EXIT, OnIDM_APP_EXIT)
   ON_COMMAND(IDM_ABOUT, OnIDM_ABOUT)
   ON_WM_CLOSE()
   ON_MESSAGE(IDOM_N_ENTITYADDREQUEST, Onidomnentityaddrequest)
   ON_MESSAGE(IDOM_N_RELATIONADDED, Onidomnrelationadded)
   ON_MESSAGE(IDOM_N_RELATIONADDREQUEST, Onidomnrelationaddrequest)
   ON_WM_DESTROY()
   ON_WM_SIZE()
   //}}AFX_MSG_MAP

   //Regen_Map
   //Regen_Map

END_MESSAGE_MAP()

CMainWindow::CMainWindow(UINT nIDTemplate, CWnd* pParentWnd)
   : CDialog((nIDTemplate) ? nIDTemplate : master, pParentWnd)
{
   //lRegen_MainVarConstruct
   m_pIDO = NULL;
   //lRegen_MainVarConstruct
   Create(master);
   //Regen_MainConstruct
   //Regen_MainConstruct

}

Ctravel theApp;

// Initialize Instance and create the application's main window
BOOL Ctravel::InitInstance()
{

   //lRegen_InitInstance
   //lRegen_InitInstance
   //Regen_MainInit
   //Regen_MainInit

   #ifdef WIN32
   Enable3dControls();                  // Initialize Ctl3D Support
   #else
   Ctl3dRegister(m_hInstance);
   Ctl3dAutoSubclass(m_hInstance);
   #endif


   //lRegen_MainRun
   //lRegen_MainRun
   m_pMainWnd = new CMainWindow(0, NULL);
   m_pMainWnd->ShowWindow(m_nCmdShow);
   m_pMainWnd->UpdateWindow();

   //Regen_MainExit
   //Regen_MainExit

   return TRUE;
}

BOOL Ctravel::ExitInstance()
{
//Regen_ExitInstance
//Regen_ExitInstance

   return CWinApp::ExitInstance();
}

// ------------- Main Window Destructor ---------
CMainWindow::~CMainWindow()
{

   //Regen_MainDestruct
   //Regen_MainDestruct

   pMenu->DestroyMenu();
   delete pMenu;

}

BOOL CMainWindow::OnInitDialog()
{
   //Regen_MainInitDlgVars
   //Regen_MainInitDlgVars
   pMenu = new CMenu;
   pMenu->LoadMenu(TRAVEL);
   SetMenu(pMenu);

   //Regen_MenuLoad
   //Regen_MenuLoad

   //Regen_MainInitDlg
   //Regen_MainInitDlg
   CDialog::OnInitDialog();
   //Regen_MainInitDlgEnd
   long lStyle = WS_VISIBLE | WS_CHILD | WS_HSCROLL | WS_VSCROLL | WS_TABSTOP;
   RECT rect;

   GetClientRect(&rect);

   m_pIDO = new CIDO;
   m_pIDO->Create(lStyle, rect, this, IDC_IDO1);

   if(m_pIDO)
   {
      m_pIDO->SetEditMode(TRUE);
      m_pIDO->SetToolsPalette(TRUE);
      m_pIDO->SetRulesEnforced(FALSE);
      m_pIDO->ReadDiagram("travel.ido");
   }

   //Regen_MainInitDlgEnd
   return TRUE;
}

void CMainWindow::PostNcDestroy()
{
   //Regen_MainPostNcDestroy
   //Regen_MainPostNcDestroy
   delete this;
}

void CMainWindow::OnClose()
{
   //Regen_WM_Close
   //Regen_WM_Close
   DestroyWindow();
   PostQuitMessage(0);
}


LRESULT CMainWindow::Onidomnentityaddrequest(WPARAM wParam, LPARAM lParam)
{
   //Regen_CMainWindow_idom_n_entityaddrequest
   CEntity entity((LPENTITY)lParam);
   LPENTITY lpentity = (LPENTITY)lParam;

   lstrcpy(lpentity->name, "Princeton");
   lstrcpy(lpentity->text, "Princeton");
   //Regen_CMainWindow_idom_n_entityaddrequest
   return 0;
}

LRESULT CMainWindow::Onidomnrelationadded(WPARAM wParam, LPARAM lParam)
{
   //Regen_CMainWindow_idom_n_relationadded
   CRelation relation((LPRELATION)lParam);


   relation.SetText("100");
   relation.Repaint();
   //Regen_CMainWindow_idom_n_relationadded
   return 0;
}

LRESULT CMainWindow::Onidomnrelationaddrequest(WPARAM wParam, LPARAM lParam)
{
   //Regen_CMainWindow_idom_n_relationaddrequest
   CRelation relation((LPRELATION)lParam);

   //Regen_CMainWindow_idom_n_relationaddrequest
   return 0;
}

void CMainWindow::OnDestroy()
{
   //Regen_CMainWindow_wm_destroy
   //Regen_CMainWindow_wm_destroy
   CDialog::OnDestroy();
}

void CMainWindow::OnSize(UINT nType, int cx, int cy)
{
   //Regen_CMainWindow_wm_size
   RECT rect;

   GetClientRect(&rect);

#ifdef DEBUG
   ASSERT_VALID(m_pIDO)
#endif
   if(m_pIDO)
      m_pIDO->SetWindowPos(NULL, 0, 0,
                           rect.right, rect.bottom,
                           SWP_NOZORDER);

   //Regen_CMainWindow_wm_size
   CDialog::OnSize(nType, cx, cy);
}

void CMainWindow::OnIDM_SHORTESTDISTANCE()
{

   //lRegen_CMainWindow_IDM_SHORTESTDISTANCE_Start
   //lRegen_CMainWindow_IDM_SHORTESTDISTANCE_Start
//Lock

   // lock so we can pass a pointer to the IDO
   CdistanceDlg Dlg(NULL, this, m_pIDO);
   int ReturnValue;

   ReturnValue = Dlg.DoModal();
   //Regen_CMainWindow_IDM_SHORTESTDISTANCE_End
   //Regen_CMainWindow_IDM_SHORTESTDISTANCE_End
}

void CMainWindow::OnIDM_FILE_PRINT()
{
   //Regen_IDM_FILE_PRINT
   if(m_pIDO)
      m_pIDO->PrintDiagram();
   //Regen_IDM_FILE_PRINT
}

void CMainWindow::OnIDM_APP_EXIT()
{
   //Regen_IDM_APP_EXIT
   //Regen_IDM_APP_EXIT
}

void CMainWindow::OnIDM_ABOUT()
{

   //lRegen_CMainWindow_IDM_ABOUT_Start
   //lRegen_CMainWindow_IDM_ABOUT_Start

   CabouttravelDlg Dlg(NULL, this);
   int ReturnValue;

   ReturnValue = Dlg.DoModal();
   //Regen_CMainWindow_IDM_ABOUT_End
   //Regen_CMainWindow_IDM_ABOUT_End
}

//Regen_CustomCode
//Regen_CustomCode
